<template>
  <div>
    <!-- Order -->
    <b-modal ref="delete-order" size="md" hide-footer title="Supprimer la commande">
      <div class="container">
        <div class="row">
          <div class="col-sm-12">
            <p>Voulez-vous supprimer/annuler la commande ?</p>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12">
            <button class="btn c-admin-button" @click="deleteCurrentOrder()" type="button">Oui
            </button>
            <button class="btn c-admin-button c-admin-button-cancel" @click="hideModalDeleteOrder"
              type="button">Non</button>
          </div>
        </div>
      </div>
    </b-modal>
    <b-modal ref="validate-order" size="md" hide-footer title="Valider la commande">
      <div class="container">
        <div class="row">
          <div class="col-sm-12">
            <p>Voulez-vous valider la commande ?</p>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12">
            <button class="btn c-admin-button" @click="validateCurrentOrder()" type="button">Oui
            </button>
            <button class="btn c-admin-button c-admin-button-cancel" @click="hideModalValidateOrder"
              type="button">Non</button>
          </div>
        </div>
      </div>
    </b-modal>
    <!-- Add a category -->
    <b-modal ref="modal-add-category" size="lg" hide-footer title="Ajouter une catégorie">
      <div class="container">
        <div class="row">
          <div class="col-sm-12">
            <form>
              <div class="form-group text-left">
                <label for="exampleInputEmail1">Nom de la catégorie</label>
                <input v-model="currentCategoryName" type="text" class="form-control" id="category"
                  placeholder="Ex : Produits Laitiers">
              </div>
            </form>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12">
            <button class="btn c-admin-button" @click="createCategory" type="button">
              <span v-if="creationMode === 'create'">Ajouter</span>
              <span v-else>Mettre à jour</span>
            </button>
            <button class="btn c-admin-button c-admin-button-cancel" @click="hideModalAddCategory"
              type="button">Annuler</button>
          </div>
        </div>
      </div>
    </b-modal>
    <!-- Add a product -->
    <b-modal ref="modal-add-product" size="lg" hide-footer title="Ajouter un produit">
      <div class="container">
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group">
              <label for="productname">Nom du produit</label>
              <input v-model="currentProductName" type="text" class="form-control" id="productname">
            </div>
            <div class="form-group">
              <label for="productDesc">Prix</label>
              <input v-model="currentProductPrice" type="number" step="0.01" class="form-control" id="productDesc">
            </div>
          </div>
          <div class="col-sm-6">
            <div class="form-group">
              <label for="productDesc">Unité</label>
              <select class="form-control" id="fampar" v-model="currentProductUnit">
                <option value="kg">kg</option>
                <option value="unite">unité</option>
              </select>
            </div>
            <div class="form-group">
              <label for="productDesc">Description</label>
              <input v-model="currentProductDesc" type="textarea" class="form-control" id="productDesc">
            </div>
            <div class="form-group">
              <label for="fampar">Categorie parente</label>
              <select class="form-control" id="fampar" v-model="productParentCat">
                <option v-for="cat in categories" v-bind:key="cat._id" :value="cat">{{cat.name}}</option>
              </select>
            </div>
          </div>
          <div class="col-sm-12">
            <div class="form-group text-left">
              <label for="productDesc">Photo (lien)</label>
              <input v-model="currentProductPhoto" type="text" class="form-control" id="productDesc">
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12 text-center">
            <button class="btn c-admin-button" @click="createProduct" type="button">
              <span v-if="creationMode === 'create' && !dataUploading">Ajouter</span>
              <span v-if="creationMode === 'update' && !dataUploading">Mettre à jour</span>
              <span v-if="dataUploading"><i class="fa fa-spinner fa-spin" aria-hidden="true" /></span>
            </button>
            <button class="btn c-admin-button c-admin-button-cancel" @click="hideModalAddProduct"
              type="button">Annuler</button>
          </div>
        </div>
      </div>
    </b-modal>
    <b-modal ref="delete-confirmation" size="lg" hide-footer hide-header>
      <div class="container">
        <div class="row">
          <div class="col-sm-12">
            <p>Etes-vous sur de supprimer ce produit ?</p>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12">
            <button class="btn c-admin-button c-admin-button-delete" @click.prevent="remove()" type="button">
              Supprimer
            </button>
            <button class="btn c-admin-button c-admin-button-cancel" @click="hideModalDelete"
              type="button">Annuler</button>
          </div>
        </div>
      </div>
    </b-modal>
    <!-- Admin page -->
    <div class="c-admin-header">
      <h2 class="mb-4 mt-1">Gestion du comptoir</h2>
      <ul class="nav justify-content-center">
        <li class="nav-item">
          <button type="button" class="btn c-admin-button" :class="{ active: currentDisplay === 'cat'}"
            @click="displaySection('cat')">Catégories</button>
        </li>
        <li class="nav-item">
          <button type="button" class="btn c-admin-button" :class="{ active: currentDisplay === 'prod'}"
            @click="displaySection('prod')">Produits</button>
        </li>
        <li class="nav-item">
          <button type="button" class="btn c-admin-button" :class="{ active: currentDisplay === 'cmd'}"
            @click="displaySection('cmd')">Commandes en cours</button>
        </li>
        <li class="nav-item">
          <button type="button" class="btn c-admin-button" :class="{ active: currentDisplay === 'arc'}"
            @click="displaySection('arc')">Commandes archivées</button>
        </li>
        <li class="nav-item">
          <button type="button" class="btn c-admin-button" :class="{ active: currentDisplay === 'mag'}"
            @click="goToStore()">Voir le magasin</button>
        </li>
      </ul>
    </div>
    <div class="container-fluid">
      <div class="row text-right mt-4 mb-4">
        <div class="col-sm-12"><button class="btn c-admin-button" @click="showModalAdd">+ Ajouter</button></div>
      </div>
      <div class="row">
        <div class="col-sm-12">
          <div v-if="dataLoading">
            <p><strong>Chargement...</strong></p>
            <i class="fa fa-2x fa-spinner fa-pulse" aria-hidden="true"></i>
          </div>
          <!-- Categories -->
          <table v-if="currentDisplay === 'cat' && !dataLoading" class="table c-admin-table">
            <thead class="thead-dark">
              <tr>
                <th scope="col">ID</th>
                <th scope="col">Nom</th>
                <th></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="cat in categories" v-bind:key="cat._id">
                <th scope="row">{{ cat._id }}</th>
                <td>{{ cat.name }}</td>
                <td class="text-right">
                  <button class="btn c-admin-button" @click="showModalUpdateCategory(cat._id, cat.nom, cat.order)"><i
                      class="fa fa-pencil" aria-hidden="true"></i></button>
                  <button class="btn c-admin-button c-admin-button-delete" @click.prevent="showModalDelete(cat._id)"><i
                      class="fa fa-trash" aria-hidden="true"></i></button>
                </td>
              </tr>
            </tbody>
          </table>
          <!-- Products -->
          <table v-if="currentDisplay === 'prod' && !dataLoading" class="table c-admin-table">
            <thead class="thead-dark">
              <tr>
                <th scope="col">#</th>
                <th scope="col">Nom</th>
                <th scope="col">Prix</th>
                <th scope="col">Unité</th>
                <th scope="col">Description</th>
                <th scope="col">Catégorie parente</th>
                <th scope="col">Photo</th>
                <th></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="prod in products" v-bind:key="prod._id">
                <td scope="row">{{ prod._id }}</td>
                <td>{{ prod.name }}</td>
                <td>{{ prod.price }}€</td>
                <td>{{ prod.unit }}</td>
                <td>{{ prod.desc }}</td>
                <td>{{ prod.parentName }}</td>
                <td><img class="c-photo-family" :src='prod.photo' alt="src\assets\logo.png"></td>
                <td class="text-right">
                  <button class="btn c-admin-button"
                    @click="showModalUpdateProduct(prod._id, prod.name, prod.price, prod.unit, prod.desc, prod.parentId, prod.photo)"><i
                      class="fa fa-pencil" aria-hidden="true"></i></button>
                  <button class="btn c-admin-button c-admin-button-delete" @click.prevent="showModalDelete(prod._id)"><i
                      class="fa fa-trash" aria-hidden="true"></i></button>
                </td>
              </tr>
            </tbody>
          </table>
          <!-- Orders -->
          <table v-if="currentDisplay === 'cmd' && !dataLoading" class="table c-admin-table">
            <thead class="thead-dark">
              <tr>
                <th scope="col">Nom</th>
                <th scope="col">Ref</th>
                <th scope="col">E-mail</th>
                <th scope="col">Tel</th>
                <th scope="col">Mode de livraison</th>
                <th scope="col">Adresse</th>
                <th scope="col">Commentaires</th>
                <th scope="col">Détail de la commande</th>
                <th></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="ord in orders" v-bind:key="ord._id">
                <th scope="row">{{ ord.name }}</th>
                <td>{{ ord._id }}</td>
                <td>{{ ord.email }}</td>
                <td>{{ ord.phone }}</td>
                <td>
                </td>
                <td>{{ ord.adress }} - {{ ord.CP }} - {{ ord.city }}</td>
                <td>{{ ord.comments }}</td>
                <td class="c-admin-table-sub-table">
              <tr class="c-admin-table-header-sub-table">
                <th>Produit</th>
                <th>Référence</th>
                <th>Prix Unitaire</th>
                <th>Quantité</th>
                <th>Prix total</th>
              </tr>
              <tr v-for="item in ord.cart" :key="item._id">
                <td>{{ item.name }}</td>
                <td>{{ item.ref }}</td>
                <td>{{ item.price }}€</td>
                <td>{{ item.quantity }}</td>
                <td>{{ item.totalProductPrice }}€</td>
              </tr>
              <tr>
                <td colspan="4"><strong>Total:</strong></td>
                <td><strong>{{ getTotalOrder(ord.cart) }}€</strong></td>
              </tr>
              </td>
              <td class="text-center">
                <button class="btn c-admin-button" @click="openValidationOrder(ord)"><i class="fa fa-check"
                    title="Valider la commande" aria-hidden="true"></i></button>
                <button class="btn c-admin-button c-admin-button-delete mt-2" @click="openDeleteOrder(ord)"><i
                    class="fa fa-trash" title="Annuler la commande" aria-hidden="true"></i></button>
              </td>
              </tr>
            </tbody>
          </table>
          <!-- Orders done -->
          <table v-if="currentDisplay === 'arc' && !dataLoading" class="table c-admin-table">
            <thead class="thead-dark">
              <tr>
                <th scope="col">Nom</th>
                <th scope="col">Ref</th>
                <th scope="col">E-mail</th>
                <th scope="col">Tel</th>
                <th scope="col">Adresse</th>
                <th scope="col">Code Postal</th>
                <th scope="col">Ville</th>
                <th scope="col">Commentaires</th>
                <th scope="col">Détail de la commande</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="ord in orders" v-bind:key="ord._id">
                <th scope="row">{{ ord.name }}</th>
                <td>{{ ord._id }}</td>
                <td>{{ ord.email }}</td>
                <td>{{ ord.phone }}</td>
                <td>{{ ord.adress }}</td>
                <td>{{ ord.CP }}</td>
                <td>{{ ord.city }}</td>
                <td>{{ ord.comments }}</td>
                <td class="c-admin-table-sub-table">
              <tr class="c-admin-table-header-sub-table">
                <th>Produit</th>
                <th>Référence</th>
                <th>Prix Unitaire</th>
                <th>Quantité</th>
                <th>Prix total</th>
              </tr>
              <tr v-for="item in ord.cart" :key="item._id">
                <td>{{ item.name }}</td>
                <td>{{ item.ref }}</td>
                <td>{{ item.price }}€</td>
                <td>{{ item.quantity }}</td>
                <td>{{ item.totalProductPrice }}€</td>
              </tr>
              <tr>
                <td colspan="4"><strong>Total:</strong></td>
                <td><strong>{{ getTotalOrder(ord.cart) }}€</strong></td>
              </tr>
              </td>
              </tr>
            </tbody>
          </table>
          <div v-if="currentDisplay === 'fac' && !dataLoading" class="row justify-content-center">
            <div class="col-md-6 col-sm-12">
              <h2>Facturation du site</h2>
              <table class="table c-admin-table">
                <thead class="thead-dark">
                  <th>Total</th>
                  <th>Frais de gestion du site (2%)</th>
                  <th>Deja réglé</th>
                  <th>A régler</th>
                </thead>
                <tbody>
                  <tr>
                    <td>{{ totalOrders }} €</td>
                    <td>{{ getFraisGestion() }} €</td>
                    <td>{{ payed }} €</td>
                    <td>{{ getFraisGestion() - payed }} €</td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<style lang="scss" scoped src="./management.scss">
</style>
<script src="./management.js">
</script>
<style lang="scss" scoped src="./../../../main.scss">
</style>